From 2d3927c90fc299911d52672fe91d981e59b8d0f9 Mon Sep 17 00:00:00 2001
From: Jeffrey C. Ollie <jeff@ocjtech.us>
Date: Sat, 25 Aug 2007 22:31:07 -0500
Subject: [PATCH] Strip out internal SHA code and use functions from gcrypt.

---
 configure.ac    |    1 +
 src/Makefile.am |    4 +-
 src/sha.c       |  108 ++++++++-----------------------------------------------
 3 files changed, 18 insertions(+), 95 deletions(-)

diff --git a/configure.ac b/configure.ac
index 91e69e3..d7c6285 100644
--- a/configure.ac
+++ b/configure.ac
@@ -46,6 +46,7 @@ AC_CHECK_FUNCS(getopt_long)
 AC_CHECK_FUNCS(getaddrinfo)
 
 AM_PATH_LIBGNUTLS(,AC_DEFINE(HAVE_GNUTLS,,"Use libgnutls"))
+AM_PATH_LIBGCRYPT(,AC_DEFINE(HAVE_LIBGCRYPT,,"Use libgcrypt"))
 
 dnl Check -Wall flag of GCC
 if test "x$GCC" = "xyes"; then
diff --git a/src/Makefile.am b/src/Makefile.am
index 20ca263..923b28b 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -25,5 +25,5 @@ libiksemel_la_SOURCES = \
 	base64.c
 
 libiksemel_la_LDFLAGS = -version-info 4:0:1 -no-undefined
-libiksemel_la_CFLAGS = $(CFLAGS) $(LIBGNUTLS_CFLAGS)
-libiksemel_la_LIBADD = $(LIBGNUTLS_LIBS)
+libiksemel_la_CFLAGS = $(CFLAGS) $(LIBGNUTLS_CFLAGS) $(LIBGCRYPT_CFLAGS)
+libiksemel_la_LIBADD = $(LIBGNUTLS_LIBS) $(LIBGCRYPT_LIBS)
diff --git a/src/sha.c b/src/sha.c
index 330e1b0..0bde079 100644
--- a/src/sha.c
+++ b/src/sha.c
@@ -4,17 +4,13 @@
 ** modify it under the terms of GNU Lesser General Public License.
 */
 
+#include <gcrypt.h>
+
 #include "common.h"
 #include "iksemel.h"
 
-static void sha_buffer (iksha *sha, const unsigned char *data, int len);
-static void sha_calculate (iksha *sha);
-
 struct iksha_struct {
-	unsigned int hash[5];
-	unsigned int buf[80];
-	int blen;
-	unsigned int lenhi, lenlo;
+	gcry_md_hd_t c;
 };
 
 iksha *
@@ -32,56 +28,37 @@ void
 iks_sha_reset (iksha *sha)
 {
 	memset (sha, 0, sizeof (iksha));
-	sha->hash[0] = 0x67452301;
-	sha->hash[1] = 0xefcdab89;
-	sha->hash[2] = 0x98badcfe;
-	sha->hash[3] = 0x10325476;
-	sha->hash[4] = 0xc3d2e1f0;
+	gcry_md_open(&sha->c, GCRY_MD_SHA1, 0);
 }
 
 void
 iks_sha_hash (iksha *sha, const unsigned char *data, size_t len, int finish)
 {
-	unsigned char pad[8];
-	unsigned char padc;
-
-	if (data && len != 0) sha_buffer (sha, data, len);
-	if (!finish) return;
-
-	pad[0] = (unsigned char)((sha->lenhi >> 24) & 0xff);
-	pad[1] = (unsigned char)((sha->lenhi >> 16) & 0xff);
-	pad[2] = (unsigned char)((sha->lenhi >> 8) & 0xff);
-	pad[3] = (unsigned char)(sha->lenhi & 0xff);
-	pad[4] = (unsigned char)((sha->lenlo >> 24) & 0xff);
-	pad[5] = (unsigned char)((sha->lenlo >> 16) & 0xff);
-	pad[6] = (unsigned char)((sha->lenlo >> 8) & 0xff);
-	pad[7] = (unsigned char)(sha->lenlo & 255);
-
-	padc = 0x80;
-	sha_buffer (sha, &padc, 1);
-
-	padc = 0x00;
-	while (sha->blen != 56)
-		sha_buffer (sha, &padc, 1);
-
-	sha_buffer (sha, pad, 8);
+	if (data && len != 0)
+		gcry_md_write(sha->c, data, len);
+	if (finish)
+		gcry_md_final(sha->c);
 }
 
 void
 iks_sha_print (iksha *sha, char *hash)
 {
+	unsigned char bin[20];
 	int i;
+	
+	memcpy(bin, gcry_md_read(sha->c, 0), 20);
 
-	for (i=0; i<5; i++)
+	for (i=0; i<20; i++)
 	{
-		sprintf (hash, "%08x", sha->hash[i]);
-		hash += 8;
+		sprintf (hash, "%02x", bin[i]);
+		hash += 2;
 	}
 }
 
 void
 iks_sha_delete (iksha *sha)
 {
+	gcry_md_close(sha->c);
 	iks_free (sha);
 }
 
@@ -95,58 +72,3 @@ iks_sha (const char *data, char *hash)
 	iks_sha_print (sha, hash);
 	iks_free (sha);
 }
-
-static void
-sha_buffer (iksha *sha, const unsigned char *data, int len)
-{
-	int i;
-
-	for (i=0; i<len; i++) {
-		sha->buf[sha->blen / 4] <<= 8;
-		sha->buf[sha->blen / 4] |= (unsigned int)data[i];
-		if ((++sha->blen) % 64 == 0) {
-			sha_calculate (sha);
-			sha->blen = 0;
-		}
-		sha->lenlo += 8;
-		sha->lenhi += (sha->lenlo < 8);
-	}
-}
-
-#define SRL(x,y) (((x) << (y)) | ((x) >> (32-(y))))
-#define SHA(a,b,f,c) \
-	for (i= (a) ; i<= (b) ; i++) { \
-		TMP = SRL(A,5) + ( (f) ) + E + sha->buf[i] + (c) ; \
-		E = D; \
-		D = C; \
-		C = SRL(B,30); \
-		B = A; \
-		A = TMP; \
-	}
-
-static void
-sha_calculate (iksha *sha)
-{
-	int i;
-	unsigned int A, B, C, D, E, TMP;
-
-	for (i=16; i<80; i++)
-		sha->buf[i] = SRL (sha->buf[i-3] ^ sha->buf[i-8] ^ sha->buf[i-14] ^ sha->buf[i-16], 1);
-
-	A = sha->hash[0];
-	B = sha->hash[1];
-	C = sha->hash[2];
-	D = sha->hash[3];
-	E = sha->hash[4];
-
-	SHA (0,  19, ((C^D)&B)^D,     0x5a827999);
-	SHA (20, 39, B^C^D,           0x6ed9eba1);
-	SHA (40, 59, (B&C)|(D&(B|C)), 0x8f1bbcdc);
-	SHA (60, 79, B^C^D,           0xca62c1d6);
-
-	sha->hash[0] += A;
-	sha->hash[1] += B;
-	sha->hash[2] += C;
-	sha->hash[3] += D;
-	sha->hash[4] += E;
-}
-- 
1.5.2.4

